#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_math2_mp_xi4.py">
#<verify4xi verification = "10" target = "pool4xi.py"/> 
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; lock4xi.py; rlock4xi.py; manager4xi.py; pool4xi.py; value4xi.py; arrayfunction4xi.py; basemanager4xi.py; baseproxy4xi.py; condition4xi.py; cpu_corecount4xi.py; current_process4xi.py"/>
#<use4xi usage = "
#  RUN
#      > call t test_math2_mp_xi4 > ..\txt\test_math2_mp_xi4.txt
#  ANALYZE
#     1) if ack2original is True <-- MATH TESTS WITH ORIGINAL MULTIPROCESSING    
#     2) if ack2dragon is True   <-- MATH TESTS WITH DRAGONIZED MULTIPROCESSING4XI   
#        a) OF TEST4      <-- main
#        b) DragonXi Test <-- 
#        c) ack2xxxxxxxx  <-- settings to test different parts and logic 
#     Option 1) is active
#            2) skipped 
#"
#/>
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_test_math2_mp_xi4',
            'print_trace4xi',
            'set_trace4xi',
            'test4',
            'test1',
            'calculate2xi',
            'noop',
            'pow3',
            'f',
            'plus',                        
            'mul',
            'calculatestar',
            'calculate']            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from ctypes import Structure, c_double
import time
import gc
import random
import queue # <--- NOT Queue as in the original example
from queue import Empty # <--- NOT from Queue import Empty
import operator
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import multiprocessing
from multiprocessing import Process
from multiprocessing import Queue
from multiprocessing import Pipe
from multiprocessing import Lock
from multiprocessing import Manager
from multiprocessing import Pool
from multiprocessing import current_process
from multiprocessing import freeze_support
from multiprocessing.sharedctypes import Value, Array
from multiprocessing.managers import BaseManager, BaseProxy
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from pipe4xi import Pipe4Xi
from lock4xi import Lock4Xi
from rlock4xi import RLock4Xi 
from manager4xi import Manager4Xi 
from pool4xi import Pool4Xi
from value4xi import Value4Xi
from arrayfunction4xi import ArrayFunction4Xi #<--- note: this must be called (Array2Xi uses the class from managers.py)
from basemanager4xi import BaseManager4Xi
from baseproxy4xi import BaseProxy4Xi
from condition4xi import Condition4Xi  
from cpu_corecount4xi import cpu_corecount4xi


from print4xi import Print4Xi
from print4xi import print4xi
from time4xi import time4xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi


from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

    
# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(STEP 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(STEP 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(STEP 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(STEP 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(STEP 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(STEP 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(STEP 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(STEP 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(STEP 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(STEP 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(STEP 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(STEP 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(STEP 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(STEP 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(STEP 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'ArrayFunction4Xi': 'NACK4TRACE',
        'BaseManager4Xi': 'NACK4TRACE',
        'BaseProxy4Xi': 'NACK4TRACE',
        'Condition4Xi': 'NACK4TRACE',
        'cpu_corecount4xi': 'NACK4TRACE',
        'Manager4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'PipeConnection4Xi': 'NACK4TRACE',      
        'Pool4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        '_MainProcess4Xi': 'NACK4TRACE',
        'Value4Xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'        
        }                             

        
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(STEP 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(STEP 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-math-two-4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Mathematics in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Mathematics in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-math-two-4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Mathematics in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Mathematics in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-math-two-4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Mathematics in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Mathematics in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate" usage = "
#   calculates with multiprocessing 
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def calculate(func, args):
    result = func(*args)
    return '%s says that %s%s = %s' % (
        multiprocessing.current_process().name,
        func.__name__, args, result
        )
#</function4xi>
         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculatestar" usage = "
#  calls calculate   
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def calculatestar(args):
    return calculate(*args)
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "mul" usage = "
#   multiplies
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def mul(a, b):
    time.sleep(0.5*random.random())
    return a * b
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "plus" usage = "
#  adds
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def plus(a, b):
    time.sleep(0.5*random.random())
    return a + b
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "f" usage = "
#   arithmetic function
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def f(x):
    return 1.0 / (x-5.0)
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "pow3" usage = "
#   power to three 
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def pow3(x):
    return x**3
    
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "noop" usage = "
#   passes
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def noop(x):
    pass
#</function4xi>
 
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2xi" usage = "
#   uses dragonized function current_process2xi in the module current_process4xi.py
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def calculate2xi(func, args):
    result = func(*args)
    return '%s says that %s%s = %s' % (
        current_process2xi().name,
        func.__name__, args, result
        )    
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test1" usage = "
#   tests multiprocessing with mathematics
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def test1():
    multiprocessing.freeze_support()    
    
    PROCESSES = multiprocessing.cpu_count()
    
    print ('PROCESSES set base on the number of CPU cores = %d\n' % PROCESSES)
    # 4
    
    #
    # Create pool
    #

    print ('Creating pool with %d processes\n' % PROCESSES)
    # Creating pool with 4 processes
    
    pool = multiprocessing.Pool(PROCESSES)
    print ('pool = %s' % pool)
    # pool = <multiprocessing.pool.Pool object at 0x0000000002C0B438>
    
    #
    # Tests
    #

    TASKS = [(mul, (i, 7)) for i in range(10)] + \
            [(plus, (i, 8)) for i in range(10)]

    results = [pool.apply_async(calculate, t) for t in TASKS]
    imap_it = pool.imap(calculatestar, TASKS)
    imap_unordered_it = pool.imap_unordered(calculatestar, TASKS)

    print ('Ordered results using pool.apply_async():')
    for r in results:
        print ('\t', r.get())
        # Ordered results using pool.apply_async():
        # PoolWorker-1 says that mul(0, 7) = 0
        # PoolWorker-2 says that mul(1, 7) = 7
        # PoolWorker-4 says that mul(2, 7) = 14
        # PoolWorker-3 says that mul(3, 7) = 21
        # PoolWorker-1 says that mul(4, 7) = 28
        # PoolWorker-2 says that mul(5, 7) = 35
        # PoolWorker-1 says that mul(6, 7) = 42
        # PoolWorker-4 says that mul(7, 7) = 49
        # PoolWorker-4 says that mul(8, 7) = 56
        # PoolWorker-3 says that mul(9, 7) = 63
        # PoolWorker-4 says that plus(0, 8) = 8
        # PoolWorker-2 says that plus(1, 8) = 9
        # PoolWorker-1 says that plus(2, 8) = 10
        # PoolWorker-4 says that plus(3, 8) = 11
        # PoolWorker-3 says that plus(4, 8) = 12
        # PoolWorker-2 says that plus(5, 8) = 13
        # PoolWorker-3 says that plus(6, 8) = 14
        # PoolWorker-1 says that plus(7, 8) = 15
        # PoolWorker-2 says that plus(8, 8) = 16
        # PoolWorker-4 says that plus(9, 8) = 17
    print()

    print ('Ordered results using pool.imap():')    
    for x in imap_it:
        print ('\t', x)
        # Ordered results using pool.imap():
        # PoolWorker-1 says that mul(0, 7) = 0
        # PoolWorker-2 says that mul(1, 7) = 7
        # PoolWorker-3 says that mul(2, 7) = 14
        # PoolWorker-1 says that mul(3, 7) = 21
        # PoolWorker-2 says that mul(4, 7) = 28
        # PoolWorker-4 says that mul(5, 7) = 35
        # PoolWorker-3 says that mul(6, 7) = 42
        # PoolWorker-2 says that mul(7, 7) = 49
        # PoolWorker-1 says that mul(8, 7) = 56
        # PoolWorker-4 says that mul(9, 7) = 63
        # PoolWorker-3 says that plus(0, 8) = 8
        # PoolWorker-4 says that plus(1, 8) = 9
        # PoolWorker-2 says that plus(2, 8) = 10
        # PoolWorker-2 says that plus(3, 8) = 11
        # PoolWorker-2 says that plus(4, 8) = 12
        # PoolWorker-2 says that plus(5, 8) = 13
        # PoolWorker-3 says that plus(6, 8) = 14
        # PoolWorker-1 says that plus(7, 8) = 15
        # PoolWorker-3 says that plus(8, 8) = 16
        # PoolWorker-1 says that plus(9, 8) = 17        
    print()

    print ('Unordered results using pool.imap_unordered():')
    for x in imap_unordered_it:
        print ('\t', x)
        # PoolWorker-4 says that mul(0, 7) = 0
        # PoolWorker-2 says that mul(3, 7) = 21
        # PoolWorker-3 says that mul(2, 7) = 14
        # PoolWorker-4 says that mul(1, 7) = 7
        # PoolWorker-1 says that mul(4, 7) = 28
        # PoolWorker-2 says that mul(5, 7) = 35
        # PoolWorker-1 says that mul(8, 7) = 56
        # PoolWorker-2 says that mul(9, 7) = 63
        # PoolWorker-3 says that mul(6, 7) = 42
        # PoolWorker-4 says that mul(7, 7) = 49
        # PoolWorker-1 says that plus(0, 8) = 8
        # PoolWorker-3 says that plus(2, 8) = 10
        # PoolWorker-4 says that plus(3, 8) = 11
        # PoolWorker-2 says that plus(1, 8) = 9
        # PoolWorker-1 says that plus(4, 8) = 12
        # PoolWorker-2 says that plus(7, 8) = 15
        # PoolWorker-4 says that plus(6, 8) = 14
        # PoolWorker-3 says that plus(5, 8) = 13
        # PoolWorker-2 says that plus(9, 8) = 17
        # PoolWorker-1 says that plus(8, 8) = 16        
    print()

    print ('Ordered results using pool.map() --- will block till complete:')
    for x in pool.map(calculatestar, TASKS):
        print ('\t', x)
        # PoolWorker-4 says that mul(0, 7) = 0
        # PoolWorker-4 says that mul(1, 7) = 7
        # PoolWorker-3 says that mul(2, 7) = 14
        # PoolWorker-3 says that mul(3, 7) = 21
        # PoolWorker-2 says that mul(4, 7) = 28
        # PoolWorker-2 says that mul(5, 7) = 35
        # PoolWorker-1 says that mul(6, 7) = 42
        # PoolWorker-1 says that mul(7, 7) = 49
        # PoolWorker-3 says that mul(8, 7) = 56
        # PoolWorker-3 says that mul(9, 7) = 63
        # PoolWorker-1 says that plus(0, 8) = 8
        # PoolWorker-1 says that plus(1, 8) = 9
        # PoolWorker-4 says that plus(2, 8) = 10
        # PoolWorker-4 says that plus(3, 8) = 11
        # PoolWorker-3 says that plus(4, 8) = 12
        # PoolWorker-3 says that plus(5, 8) = 13
        # PoolWorker-1 says that plus(6, 8) = 14
        # PoolWorker-1 says that plus(7, 8) = 15
        # PoolWorker-2 says that plus(8, 8) = 16
        # PoolWorker-2 says that plus(9, 8) = 17        
    print()

    #
    # Simple benchmarks
    #

    N = 100000
    print ('def pow3(x): return x**3')

    t = time.time()
    #A = map(pow3, range(N)) <--- range caused error
    A = map(pow3, range(N))
    print ('\tmap(pow3, range(%d)):\n\t\t%s seconds' % \
          (N, time.time() - t))
          
    # def pow3(x): return x**3
    # 	map(pow3, range(100000)):
    # 		0.0 seconds
    # 	pool.map(pow3, range(100000)):
    # 		0.07700419425964355 seconds
    # 	list(pool.imap(pow3, range(100000), chunksize=12500)):
    # 		0.09100484848022461 seconds
          
          
    t = time.time()
    B = pool.map(pow3, range(N))
    print ('\tpool.map(pow3, range(%d)):\n\t\t%s seconds' % \
          (N, time.time() - t))
          
    # def noop(x): pass
    # L = [None] * 1000000
    # 	map(noop, L):
    # 		0.0 seconds
    # 	pool.map(noop, L):
    # 		0.26001501083374023 seconds
    # 	list(pool.imap(noop, L, chunksize=125000)):
    # 		0.3740220069885254 seconds
          
          
          
    t = time.time()
    C = list(pool.imap(pow3, range(N), chunksize=N//8))
    print ('\tlist(pool.imap(pow3, range(%d), chunksize=%d)):\n\t\t%s' \
          ' seconds' % (N, N//8, time.time() - t))

    #assert A == B == C, (len(A), len(B), len(C)) <--- compilation error
    #assert (A == B == C, (len(A), len(B), len(C))) <--- unresolved, not even this ok !
    print ()
    L = [None] * 1000000
    print ('def noop(x): pass')
    print ('L = [None] * 1000000')

    t = time.time()
    A = map(noop, L)
    print ('\tmap(noop, L):\n\t\t%s seconds' % \
          (time.time() - t))

    t = time.time()
    B = pool.map(noop, L)
    print ('\tpool.map(noop, L):\n\t\t%s seconds' % \
          (time.time() - t))

    t = time.time()
    C = list(pool.imap(noop, L, chunksize=len(L)//8))
    print ('\tlist(pool.imap(noop, L, chunksize=%d)):\n\t\t%s seconds' % \
          (len(L)//8, time.time() - t))

    #assert (A == B == C, (len(A), len(B), len(C)))
    print ()
    del A, B, C, L

    #
    # Test error handling
    #

    print ('Testing error handling:')

    try:
        print (pool.apply(f, (5,)))
    except ZeroDivisionError:
        print ('\tGot ZeroDivisionError as expected from pool.apply()')
    else:
        #raise AssertionError, 'expected ZeroDivisionError'
        raise AssertionError('expected ZeroDivisionError')
    try:
        print (pool.map(f, range(10)))
    except ZeroDivisionError:
        print ('\tGot ZeroDivisionError as expected from pool.map()')
    else:
        raise AssertionError ('expected ZeroDivisionError')

    try:
        print (list(pool.imap(f, range(10))))
    except ZeroDivisionError:
        print ('\tGot ZeroDivisionError as expected from list(pool.imap())')
    else:
        raise AssertionError ('expected ZeroDivisionError')

    it = pool.imap(f, range(10))
    for i in range(10):
        try:
            x = it.next()
        except ZeroDivisionError:
            if i == 5:
                pass
        except StopIteration:
            break
        else:
            if i == 5:
                raise AssertionError ('expected ZeroDivisionError')

    assert (i == 9)
    print ('\tGot ZeroDivisionError as expected from IMapIterator.next()')
    print ()
    #
    # Testing timeouts
    #

    print ('Testing ApplyResult.get() with timeout:',)
    res = pool.apply_async(calculate, TASKS[0])
    while 1:
        sys.stdout.flush()
        try:
            sys.stdout.write('\n\t%s' % res.get(0.02))
            break
        except multiprocessing.TimeoutError:
            sys.stdout.write('.')
    print()


    print ('Testing IMapIterator.next() with timeout:')
    it = pool.imap(calculatestar, TASKS)
    while 1:
        sys.stdout.flush()
        try:
            sys.stdout.write('\n\t%s' % it.next(0.02))
        except StopIteration:
            break
        except multiprocessing.TimeoutError:
            sys.stdout.write('.')
    print()
    # 	PoolWorker-1 says that mul(0, 7) = 0
    # 	PoolWorker-3 says that mul(1, 7) = 7...
    # 	PoolWorker-4 says that mul(2, 7) = 14
    # 	PoolWorker-2 says that mul(3, 7) = 21
    # 	PoolWorker-2 says that mul(4, 7) = 28.
    # 	PoolWorker-2 says that mul(5, 7) = 35......
    # 	PoolWorker-3 says that mul(6, 7) = 42
    # 	PoolWorker-1 says that mul(7, 7) = 49.......
    # 	PoolWorker-4 says that mul(8, 7) = 56
    # 	PoolWorker-2 says that mul(9, 7) = 63
    # 	PoolWorker-1 says that plus(0, 8) = 8
    # 	PoolWorker-1 says that plus(1, 8) = 9...
    # 	PoolWorker-3 says that plus(2, 8) = 10......
    # 	PoolWorker-1 says that plus(3, 8) = 11
    # 	PoolWorker-2 says that plus(4, 8) = 12
    # 	PoolWorker-4 says that plus(5, 8) = 13
    # 	PoolWorker-4 says that plus(6, 8) = 14.....
    # 	PoolWorker-4 says that plus(7, 8) = 15.
    # 	PoolWorker-3 says that plus(8, 8) = 16......
    # 	PoolWorker-2 says that plus(9, 8) = 17

    #
    # Testing callback
    #

    print ('Testing callback:')

    A = []
    B = [56, 0, 1, 8, 27, 64, 125, 216, 343, 512, 729]

    r = pool.apply_async(mul, (7, 8), callback=A.append)
    r.wait()

    r = pool.map_async(pow3, range(10), callback=A.extend)
    r.wait()

    if A == B:
        print ('\tcallbacks succeeded\n')
    else:
        print ('\t*** callbacks failed\n\t\t%s != %s\n' % (A, B))

    #
    # Check there are no outstanding tasks
    #

    # assert (not pool._cache, 'cache = %r' % pool._cache) <--- always true !?

    #
    # Check close() methods
    #

    print ('Testing close():')

    for worker in pool._pool:
        assert (worker.is_alive())

    result = pool.apply_async(time.sleep, [0.5])
    pool.close()
    pool.join()

    assert (result.get() is None)

    for worker in pool._pool:
        assert (not worker.is_alive())

    print ('\tclose() succeeded\n')

    #
    # Check terminate() method
    #

    print ('Testing terminate():')

    pool = multiprocessing.Pool(2)
    DELTA = 0.1
    ignore = pool.apply(pow3, [2])
    results = [pool.apply_async(time.sleep, [DELTA]) for i in range(100)]
    pool.terminate()
    pool.join()

    for worker in pool._pool:
        assert (not worker.is_alive())

    print ('\tterminate() succeeded\n')

    #
    # Check garbage collection
    #

    print ('Testing garbage collection:')

    pool = multiprocessing.Pool(2)
    DELTA = 0.1
    processes = pool._pool
    ignore = pool.apply(pow3, [2])
    results = [pool.apply_async(time.sleep, [DELTA]) for i in range(100)]

    results = pool = None

    time.sleep(DELTA * 2)

    for worker in processes:
        if worker.is_alive():
            print ('\t alive worker: ', worker)
            # alive worker:  <Process(PoolWorker-7, started daemon)>
            # alive worker:  <Process(PoolWorker-8, started daemon)>
        else:
            print ('\t dead worker: ', worker)    
        

    print ('\tgarbage collection succeeded\n')
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test4" usage = "
#   testing calculations with dragonized multiprocessing4xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------
def test4():

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test(00) cpu_corecount4xi() = %d\n' % cpu_corecount4xi()) 
    # 4
    
    #
    # Create pool2xi
    #

    PROCESSES = 4
    print ('Creating dragonized pool with %d processes\n' % PROCESSES)
    pool2xi = Pool4Xi(PROCESSES)
    print ('pool2xi = %s' % pool2xi)
    
    #
    # Tests
    #
    TASKS = [(mul, (i, 7)) for i in range(10)] + \
            [(plus, (i, 8)) for i in range(10)]

    results = [pool2xi.apply_async(calculate, t) for t in TASKS]
    imap_it = pool2xi.imap(calculatestar, TASKS)
    imap_unordered_it = pool2xi.imap_unordered(calculatestar, TASKS)
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (01) Ordered results using pool2xi.apply_async():')
    for r in results:
        print ('\t', r.get())
    print()
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (02) Ordered results using pool2xi.imap():')    
    for x in imap_it:
        print ('\t', x)
    print()
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (03) Unordered results using pool2xi.imap_unordered():')
    for x in imap_unordered_it:
        print ('\t', x)
    print()
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (04) Ordered results using pool2xi.map() --- will block till complete:')
    for x in pool2xi.map(calculatestar, TASKS):
        print ('\t', x)
    print()

    #
    # Simple benchmarks
    #
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    N = 100000
    print ('\n DragonXi Test (05) def pow3(x): return x**3')

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    t = time.time()
    A = map(pow3, range(N))
    print ('\n DragonXi Test (06) \tmap(pow3, range(%d)):\n\t\t%s seconds' % \
          (N, time.time() - t))
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    t = time.time()
    B = pool2xi.map(pow3, range(N))
    print ('\n DragonXi Test (07) \tpool.map(pow3, range(%d)):\n\t\t%s seconds' % \
          (N, time.time() - t))
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    t = time.time()
    C = list(pool2xi.imap(pow3, range(N), chunksize=N//8))
    print ('\n DragonXi Test (08) \tlist(pool2xi.imap(pow3, range(%d), chunksize=%d)):\n\t\t%s' \
          ' seconds' % (N, N//8, time.time() - t))

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ()
    L = [None] * 1000000
    print ('\n DragonXi Test (09) def noop(x): pass')

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (10) L = [None] * 1000000')

    
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    t = time.time()
    A = map(noop, L)
    print ('\n DragonXi Test (11) \tmap(noop, L):\n\t\t%s seconds' % \
          (time.time() - t))

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------          
    t = time.time()
    B = pool2xi.map(noop, L)
    print ('\n DragonXi Test (12) \tpool2xi.map(noop, L):\n\t\t%s seconds' % \
          (time.time() - t))

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------          
    t = time.time()
    C = list(pool2xi.imap(noop, L, chunksize=len(L)//8))
    print ('\n DragonXi Test (13) \tlist(pool2xi.imap(noop, L, chunksize=%d)):\n\t\t%s seconds' % \
          (len(L)//8, time.time() - t))

    #assert (A == B == C, (len(A), len(B), len(C)))
    print ()
    del A, B, C, L

    #
    # Test error handling
    #
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (14) Testing error handling:')

    try:
        print (pool2xi.apply(f, (5,)))
    except ZeroDivisionError:
        print ('\n Got ZeroDivisionError as expected from pool.apply()')
    else:
        #raise AssertionError, 'expected ZeroDivisionError'
        raise AssertionError('expected ZeroDivisionError')
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------    
    try:
        print ('\n DragonXi Test (15) ', pool2xi.map(f, range(10)))
    except ZeroDivisionError:
        print ('\tGot ZeroDivisionError as expected from pool2xi.map()')
    else:
        raise AssertionError ('expected ZeroDivisionError')
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    try:
        print ('\n DragonXi Test (16) ', list(pool2xi.imap(f, range(10))))
    except ZeroDivisionError:
        print ('\n Got ZeroDivisionError as expected from list(pool2xi.imap())')
    else:
        raise AssertionError ('expected ZeroDivisionError')

    it = pool2xi.imap(f, range(10))
    for i in range(10):
        try:
            x = it.next()
        except ZeroDivisionError:
            if i == 5:
                pass
        except StopIteration:
            break
        else:
            if i == 5:
                raise AssertionError ('expected ZeroDivisionError')
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    assert (i == 9)
    print ('\n DragonXi Test (17) \tGot ZeroDivisionError as expected from IMapIterator.next()')
    print ()
    #
    # Testing timeouts
    #
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (18) Testing ApplyResult.get() with timeout:',)
    res = pool2xi.apply_async(calculate, TASKS[0])
    while 1:
        sys.stdout.flush()
        try:
            sys.stdout.write('\n\t%s' % res.get(0.02))
            break
        except multiprocessing.TimeoutError:
            sys.stdout.write('.')
    print()

    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (19) Testing IMapIterator.next() with timeout:')
    it = pool2xi.imap(calculatestar, TASKS)
    while 1:
        sys.stdout.flush()
        try:
            sys.stdout.write('\n\t%s' % it.next(0.02))
        except StopIteration:
            break
        except multiprocessing.TimeoutError:
            sys.stdout.write('.')
    print()


    #
    # Testing callback
    #
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (20) Testing callback:')

    A = []
    B = [56, 0, 1, 8, 27, 64, 125, 216, 343, 512, 729]

    r = pool2xi.apply_async(mul, (7, 8), callback=A.append)
    r.wait()

    r = pool2xi.map_async(pow3, range(10), callback=A.extend)
    r.wait()

    if A == B:
        print ('\tcallbacks succeeded\n')
    else:
        print ('\t*** callbacks failed\n\t\t%s != %s\n' % (A, B))

    #
    # Check there are no outstanding tasks
    #

    # assert (not pool2xi._cache, 'cache = %r' % pool2xi._cache) <--- removed

    #
    # Check close() methods
    #
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (21) Testing close():')

    for worker in pool2xi._pool:
        assert (worker.is_alive())

    result = pool2xi.apply_async(time.sleep, [0.5])
    pool2xi.close()
    pool2xi.join()

    assert (result.get() is None)

    for worker in pool2xi._pool:
        assert (not worker.is_alive())

    print ('\tclose() succeeded\n')

    #
    # Check terminate() method
    #
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (22) Testing terminate()')
    pool2xi = Pool4Xi(2)
    DELTA = 0.1
    ignore = pool2xi.apply(pow3, [2])
    results = [pool2xi.apply_async(time.sleep, [DELTA]) for i in range(100)]
    pool2xi.terminate()
    pool2xi.join()
    for worker in pool2xi._pool:
        assert (not worker.is_alive())
    print ('\tterminate() succeeded\n')

    #
    # Check garbage collection
    #
    # 
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n DragonXi Test (23) Testing garbage collection')

    pool2xi = Pool4Xi(2)
    DELTA = 0.1
    processes = pool2xi._pool
    ignore = pool2xi.apply(pow3, [2])
    results = [pool2xi.apply_async(time.sleep, [DELTA]) for i in range(100)]

    results = pool2xi = None

    time.sleep(DELTA * 2)

    for worker in processes:
        assert (not worker.is_alive())

    print ('\tgarbage collection succeeded\n')
    # --------------------------------------------------------------------------------------------
    #
    # --------------------------------------------------------------------------------------------
    print ('\n All tests with dragonized multiprocessing modules done!')
#</function4xi>
  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_math2_mp_xi4" usage = "
#   testing mathematics with dragonized multiprocessing
#">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_math2_mp_xi4():
    global t2xi
    global trace_object_count    
          
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(STEP 0/33) OF TEST_MATH2_MP_XI4 - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    

    # ---------------------------------------------------------------------------------------------------------
    # ALL TRIALS OF TESTS                          
    # ---------------------------------------------------------------------------------------------------------    
    try:
        ack2original = True
        if ack2original is True:
            # ------------------------------------------------------------------------------------------------
            # MATH TESTS WITH ORIGINAL MULTIPROCESSING                          
            # ------------------------------------------------------------------------------------------------
            print("(STEP 1A/33) OF TEST_MATH2_MP_XI4 - CALLING TEST1 ", time4xi())
            # 01:16:56 02/28/13 Pacific Standard Time
            
            test1()
            print("(STEP 1B/33) OF TEST_MATH2_MP_XI4 - PERFORMED TEST1 ", time4xi())
        else:    
            print("(STEP 1C/33) OF TEST_MATH2_MP_XI4 - SKIPPED TEST1 ", time4xi())
        
        ack2dragon = False
        if ack2dragon is True:
            # ------------------------------------------------------------------------------------------------
            # MATH TESTS WITH DRAGONIZED MULTIPROCESSING4XI                          
            # ------------------------------------------------------------------------------------------------        
            print("(STEP 2A/33) OF TEST_MATH2_MP_XI4 - CALLING TEST4 ", time4xi())
            test4()
            print("(STEP 2B/33) OF TEST_MATH2_MP_XI4 - PERFORMED TEST4 ", time4xi())
        else:
            print("(STEP 2C/33) OF TEST_MATH2_MP_XI4 - SKIPPED TEST4 ", time4xi())
            # 01:22:16 02/28/13 Pacific Standard Time    
    finally:        
            
                    
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
       
        
#</function4xi>        
    
 
# -------------------------------------------------------------------------------------------------
# main                              
#<function4xi function = "main" usage = "
#   main function to test mathematics with multiprocessing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main(): 
    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI ",time4xi())  
    # 01:16:56 02/28/13 Pacific Standard Time
    print('=' *33)
        
    test_math2_mp_xi4() 
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI ",time4xi())    
    print('=' *33) 
    
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':

    main()
    
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#    
# None
#"
#>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_math2_mp_xi4.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
